disable_portal_stuff=false

mcl_portalgun={new=0,checkpoints={}}
dofile(minetest.get_modpath("mcl_portalgun") .. "/gravityuse.lua") -- the gravity part of mcl_portalgun
dofile(minetest.get_modpath("mcl_portalgun") .. "/craft.lua")
dofile(minetest.get_modpath("mcl_portalgun") .. "/stuff.lua") -- security cam
if disable_portal_stuff==false and minetest.get_modpath("mesecons")~=nil then
dofile(minetest.get_modpath("mcl_portalgun") .. "/weightedstoragecube.lua") -- weighted storage cube
dofile(minetest.get_modpath("mcl_portalgun") .. "/powerball.lua") -- the poweball
dofile(minetest.get_modpath("mcl_portalgun") .. "/other.lua")
end

mcl_portalgun_portal={}
mcl_portalgun_portal_tmp_user_abort=0
mcl_portalgun_portal_tmp_user=""
local mcl_portalgun_timer=1.2
local mcl_portalgun_time=0
mcl_portalgun_lifelime=1200		--deletes portals that not used after a while
mcl_portalgun_max_rage=100
mcl_portalgun_max_use_per_secund_time=4	--destroys the portal if excessive used 
mcl_portalgun_max_use_per_secund=25		--4 & 25 is default = teleported (teleported 25 times in 4 sec)


function mcl_portalgun_param2(pos,param2,r)
	local pos2={x=pos.x,y=pos.y,z=pos.z}
	if r then
		if param2==0 then
		pos2.x=pos2.x-1
		elseif param2==1 then pos2.z=pos2.z+1
		elseif param2==2 then pos2.x=pos2.x+1
		elseif param2==3 then pos2.z=pos2.z-1
		end
	else
		if param2==0 then
		pos2.x=pos2.x+1
		elseif param2==1 then pos2.z=pos2.z-1
		elseif param2==2 then pos2.x=pos2.x-1
		elseif param2==3 then pos2.z=pos2.z+1
		end
	end
	return pos2
end


local function mcl_portalgun_getLength(a)-- get length of an array / table
	local count = 0
	for _ in pairs(a) do count = count + 1 end
	return count
end

function portal_delete(name,n)	-- using set_hp & :punch instand of :remove ... no risk for crash if something attach it
	if mcl_portalgun_portal[name]==nil then return end
	if (n==1 or n==0) and mcl_portalgun_portal[name].portal1~=nil then
		if n==0 then 
			local pos=mcl_portalgun_portal[name].portal1:getpos()
			if pos~=nil then minetest.sound_play("mcl_portalgun_closeportals", {pos=pos,max_hear_distance = 20, gain = 1}) end
		end
		mcl_portalgun_portal[name].portal1_active=false
		mcl_portalgun_portal[name].portal1:set_hp(0)
		mcl_portalgun_portal[name].portal1:punch(mcl_portalgun_portal[name].portal1, {full_punch_interval=1.0,damage_groups={fleshy=9000}}, "mcl_tools:pick_iron", nil)
	end
	if (n==2 or n==0) and mcl_portalgun_portal[name].portal2~=nil then
		if n==0 then 
			local pos=mcl_portalgun_portal[name].portal2:getpos()
			if pos~=nil then minetest.sound_play("mcl_portalgun_closeportals", {pos=pos,max_hear_distance = 20, gain = 1}) end
		end
		mcl_portalgun_portal[name].portal2_active=false
		mcl_portalgun_portal[name].portal2:set_hp(0)
		mcl_portalgun_portal[name].portal2:punch(mcl_portalgun_portal[name].portal2, {full_punch_interval=1.0,damage_groups={fleshy=9000}}, "mcl_tools:pick_iron", nil)
	end
	if n==0 then mcl_portalgun_portal[name]=nil end
end

minetest.register_on_leaveplayer(function(player)-- 	deletes user the profile (saveing memory)
	local name=player:get_player_name()
	portal_delete(name,0)
	mcl_portalgun_portal[name]=nil
end)
minetest.register_on_dieplayer(function(player)
	local name=player:get_player_name()
	portal_delete(name,0)
	mcl_portalgun_portal[name]=nil
end)


mcl_portalgun_on_step=function(self, dtime)
	local name=self.user

	if mcl_portalgun_portal[self.user]==nil then
		self.object:remove()
		return self
	end

	if (self.project==1 and self.use~=mcl_portalgun_portal[self.user].portal1_use)
	or (self.project==2 and self.use~=mcl_portalgun_portal[self.user].portal2_use) then
		self.object:remove()
		return self
	end

	if mcl_portalgun_portal[name].lifelime<0 then
		portal_delete(name,0)
		return self
	end

	if mcl_portalgun_portal[name].portal1_active and mcl_portalgun_portal[name].portal2_active then -- makes lifetime equal when both is acive, or it will be half
		mcl_portalgun_portal[name].lifelime=mcl_portalgun_portal[name].lifelime-0.5
	else
		mcl_portalgun_portal[name].lifelime=mcl_portalgun_portal[name].lifelime-1
		return self						-- abort when only 1 is active (saves cpu)
	end

	if mcl_portalgun_portal[name].timer>0 then				-- makes teleported stuff wont move back at same time (bug fix)
		mcl_portalgun_portal[name].timer=mcl_portalgun_portal[name].timer-dtime
		return self
	end




	if self.portal_max_use>0 then				-- makes teleported stuff wont move back at same time (bug fix)
		self.portal_max_use_time=self.portal_max_use_time+dtime
		if self.portal_max_use>=mcl_portalgun_max_use_per_secund then
			portal_delete(name,self.project)
			return self
		elseif self.portal_max_use_time>=mcl_portalgun_max_use_per_secund_time then
			self.portal_max_use_time=0
			self.portal_max_use=0
		end
	end

	local pos1=0
	local pos2=0
	local d1=0
	local d2=0

	if self.project==1 then
		pos1=mcl_portalgun_portal[name].portal1_pos
		pos2=mcl_portalgun_portal[name].portal2_pos
		d1=mcl_portalgun_portal[name].portal1_dir
		d2=mcl_portalgun_portal[name].portal2_dir
	else
		pos1=mcl_portalgun_portal[name].portal2_pos
		pos2=mcl_portalgun_portal[name].portal1_pos
		d1=mcl_portalgun_portal[name].portal2_dir
		d2=mcl_portalgun_portal[name].portal1_dir
	end


	if pos2~=0 and pos1~=0 then
		for ii, ob in pairs(minetest.get_objects_inside_radius(pos1, self.area)) do
			if pos2~=0 then
				if (ob:is_player() ) or (ob:get_luaentity() and ob:get_luaentity().mcl_portalgun~=1 and ob:get_luaentity().name:find(":text",4)==nil) then

				
				if ob:get_attach() then
					ob:set_detach()
					ob:setacceleration({x=0, y=-10, z=0})
				end
						--set velocity then teleport
				local p=pos2
				local x=0
				local y=0
				local z=0
				local dis=2
				if p==nil or p.x==nil then
					return self
				end


				if ob:is_player() then
					local v=ob:get_player_velocity()
					local player_name=ob:get_player_name()
					mcl_portalgun_power.user=player_name
					mcl_portalgun_power.target=ob
					local vv={x=v.x,y=v.y,z=v.z}
									-- get the highest velocity
					dis=2
					if vv.x+vv.y+vv.z<=0.3 then
						if self.small==true then
						vv.x=1.4
					else
						vv.x=2
						end
					end
					if vv.x+vv.y+vv.z==0 then vv.x=2 end
					if vv.x<0 then vv.x=vv.x*-1 end
					if vv.y<0 then vv.y=vv.y*-1 end
					if vv.z<0 then vv.z=vv.z*-1 end
					if vv.x>vv.z then vv.a=vv.x else vv.a=vv.z end
					if vv.a<vv.y then vv.a=vv.y end
					mcl_portalgun_power_tmp_power=vv.a
					local m=minetest.add_entity(ob:getpos(), "mcl_portalgun:power2")
					ob:set_attach(m, "", {x=0,y=0,z=0}, {x=0,y=0,z=0})
					m:setvelocity(v)
					m:setacceleration({x=0,y=-10,z=0})
					ob=m
					
				end

				if ob:is_player()==false then
					local v=ob:getvelocity() 
					if v.x<0 then v.x=v.x*-1 end
					if v.y<0 then v.y=v.y*-1 end
					if v.z<0 then v.z=v.z*-1 end

					local vv=0		-- get the highest velocity
					if v.x>v.z then vv=v.x else vv=v.z end
					if vv<v.y then vv=v.y end
					v.x=0
					v.y=0
					v.z=0
					if d2=="x+" then v.x=vv end
					if d2=="x-" then v.x=vv*-1 end
					if d2=="y+" then v.y=vv end
					if d2=="y-" then v.y=vv*-1 end
					if d2=="z+" then v.z=vv end
					if d2=="z-" then v.z=vv*-1 end
					ob:setvelocity({x=v.x, y=v.y, z=v.z})
				end
					if d2=="x+" then x=2
					elseif d2=="x-" then x=-dis
					elseif d2=="y+" then y=dis
					elseif d2=="y-" then y=-dis
					elseif d2=="z+" then z=dis
					elseif d2=="z-" then z=-dis
					end
				local obpos={x=p.x+x,y=p.y+y,z=p.z+z}
				mcl_portalgun_portal[name].timer=0.2
				self.portal_max_use=self.portal_max_use+1
				ob:moveto(obpos,false)
				mcl_portalgun_portal[name].lifelime=mcl_portalgun_lifelime
				minetest.sound_play("mcl_portalgun_teleport", {pos=mcl_portalgun_portal[name].portal1_pos,max_hear_distance = 10, gain = 30})
				minetest.sound_play("mcl_portalgun_teleport", {pos=mcl_portalgun_portal[name].portal2_pos,max_hear_distance = 10, gain = 30})
				end		--end of set velocity part then teleport
			end
		end
	end
end

minetest.register_entity("mcl_portalgun:portal",{		-- the portals
	hp_max=10000,
	visual = "mesh",
	mesh = "mcl_portalgun_portal_xp.obj",
	physical = false,
	textures ={"mcl_portalgun_blue.png"},
	visual_size = {x=1, y=1},
	spritediv = {x=7, y=0},
	collisionbox = {0,0,0,0,0,0},
	timer=0,
	user="",
	project=1,
	mcl_portalgun=1,
	portal_max_use=0,
	portal_max_use_time=0,
	area=2,
	small=false,
get_staticdata = function(self)
                return minetest.serialize({
		user= self.user,
		project=self.project,
		use=self.use
                })
        end,
on_activate= function(self, staticdata)
	local data=minetest.deserialize(staticdata)
	if data and type(data) == "table" then
		self.user = data.user
		self.project = data.project
		self.use=data.use
		if mcl_portalgun_portal[self.user]==nil then
			self.object:remove()
			return self
		end
		if (self.project==1 and self.use~=mcl_portalgun_portal[self.user].portal1_use)
		or (self.project==2 and self.use~=mcl_portalgun_portal[self.user].portal2_use) then 
			self.object:remove()
			return self
		end
	elseif mcl_portalgun_portal_tmp_user~="" then
		self.user=mcl_portalgun_portal_tmp_user
		mcl_portalgun_portal_tmp_user=""
		self.project=mcl_portalgun_portal[self.user].project

		if self.project==1 then-- if inactivated then activated and another portal is created: remove
			self.use=mcl_portalgun_portal[self.user].portal1_use
		else
			self.use=mcl_portalgun_portal[self.user].portal2_use
		end

	else
		self.object:remove()
		return self
	end

	if mcl_portalgun_portal[self.user]==nil then
		self.object:remove()
		return self
	end

	local d=""
	if self.project==1 then
		d=mcl_portalgun_portal[self.user].portal1_dir
		self.object:set_properties({textures = {"mcl_portalgun_blue.png"}})
	else
		d=mcl_portalgun_portal[self.user].portal2_dir
		self.object:set_properties({textures = {"mcl_portalgun_orange.png"}})
	end
	if d=="x+" then self.object:setyaw(math.pi * 0)
	elseif d=="x-" then self.object:setyaw(math.pi * 1)
	elseif d=="y+" then self.object:set_properties({mesh = "mcl_portalgun_portal_yp.obj",}) -- becaouse there is no "setpitch"
	elseif d=="y-" then self.object:set_properties({mesh = "mcl_portalgun_portal_ym.obj",}) -- becaouse there is no "setpitch"
	elseif d=="z+" then self.object:setyaw(math.pi * 0.5) 
	elseif d=="z-" then self.object:setyaw(math.pi * 1.5)
	end
	if d=="y+" then
		local pos1={}
		if self.project==1 then
			pos1=mcl_portalgun_portal[self.user].portal1_pos
		else
			pos1=mcl_portalgun_portal[self.user].portal2_pos
		end
		if mcl_portalgun_portal[self.user].y>8 then
			pos1.y=pos1.y+1
		end
		if mcl_portalgun_portal[self.user].y>12 then
			pos1.y=pos1.y+1
		end
		if self.project==1 then
			mcl_portalgun_portal[self.user].portal1_pos=pos1
		else
			mcl_portalgun_portal[self.user].portal2_pos=pos1
		end
	elseif string.find(d,"y",1)==nil and (mcl_portalgun_portal[self.user].x+mcl_portalgun_portal[self.user].z<2.5) then
		self.area=1.2
		self.small=true
		self.object:set_properties({visual_size = {x=0.7, y=0.7},})
	end
	end,
on_step=mcl_portalgun_on_step,
})


minetest.register_tool("mcl_portalgun:gun1", {
	description = "Portalgun (blue)",
	inventory_image = "mcl_portalgun_gun_blue.png",
	range = 5,
	wield_image = "mcl_portalgun_gun_blue.png",
	groups = {not_in_creative_inventory=1},
on_place=function(itemstack, user, pointed_thing)
	mcl_portalgun_mode(itemstack, user, pointed_thing)
	return itemstack
end,
on_use = function(itemstack, user, pointed_thing)
	mcl_portalgun_onuse(itemstack, user, pointed_thing)
	return itemstack
end
})
minetest.register_tool("mcl_portalgun:gun2", {
	description = "Portalgun (orange)",
	inventory_image = "mcl_portalgun_gun_orange.png",
	range = 5,
	wield_image = "mcl_portalgun_gun_orange.png",
	groups = {not_in_creative_inventory=1},
on_place=function(itemstack, user, pointed_thing)
	mcl_portalgun_mode(itemstack, user, pointed_thing)
	return itemstack
end,
on_use = function(itemstack, user, pointed_thing)
	mcl_portalgun_onuse(itemstack, user, pointed_thing)
	return itemstack
end
})

minetest.register_tool("mcl_portalgun:gun", {
	description = "Portalgun",
	inventory_image = "mcl_portalgun_gun.png",
	range = 5,
	wield_image = "mcl_portalgun_gun.png",
	groups = {not_in_creative_inventory=0},
on_place=function(itemstack, user, pointed_thing)
	mcl_portalgun_mode(itemstack, user, pointed_thing)
	return itemstack
end,
on_use = function(itemstack, user, pointed_thing)
	mcl_portalgun_onuse(itemstack, user, pointed_thing)
	return itemstack
end
})


function mcl_portalgun_mode(itemstack, user, pointed_thing)	-- change modes
	local item=itemstack:to_table()
	local meta=minetest.deserialize(item["metadata"])
	local mode=0
	if meta==nil then
		meta={}
		mode=1
		minetest.chat_send_player(user:get_player_name(), "<mcl_portalgun> PLACE to change portal mode (or LEFT+RIGHTCLICK to use the other)")
		minetest.chat_send_player(user:get_player_name(), "<mcl_portalgun> LEFTCLICK on an object to carry it, CLICK AGAIN to release")
		minetest.chat_send_player(user:get_player_name(), "<mcl_portalgun> SHIFT+LEFTCLICK to close both portals (or wait 40sec until it removes it self)")
	end
	if meta.mode==nil then meta.mode=2 end
	mode=(meta.mode)
	if mode==1 then
		mode=2
	else
		mode=1
	end
	meta.mode=mode
	item.name="mcl_portalgun:gun"..mode
	item.metadata=minetest.serialize(meta)
	itemstack:replace(item)
	minetest.sound_play("mcl_portalgun_mode", {pos=user:getpos(),max_hear_distance = 5, gain = 1})
end


local function rnd(r)
return math.floor(r+ 0.5)
end

function mcl_portalgun_onuse(itemstack, user, pointed_thing) -- using the gun

		if pointed_thing.type=="object" then
			mcl_portalgun_gravity(itemstack, user, pointed_thing)
			return itemstack
		end

		local pos = user:getpos()
		local dir = user:get_look_dir()
		local key = user:get_player_control()
		local name=user:get_player_name()
		local exist=0

		local item=itemstack:to_table()
		local mode=minetest.deserialize(item["metadata"])
		if mode==nil then
			mcl_portalgun_mode(itemstack, user, pointed_thing) 
			return itemstack
		else
			mode=mode.mode
		end

		local ob={}
		ob.project=1
		ob.lifelime=mcl_portalgun_lifelime
		ob.portal1=0
		ob.portal2=0
		ob.portal1_dir=0
		ob.portal2_dir=0
		ob.portal2_pos=0
		ob.portal1_pos=0
		ob.user = user:get_player_name()

		if mcl_portalgun_portal[name]==nil then	--	new portal profile
			mcl_portalgun_portal[name]={lifelime=mcl_portalgun_lifelime,project=1,timer=0,portal1_active=false,portal2_active=false,portal1_use=0,portal2_use=0}
		end

		if key.RMB and mode==2 then -- hold rmbutton to use the other one (like diplazer)
			mode=1
		elseif key.RMB and mode==1 then
			mode=2
		end

		if key.sneak then
			portal_delete(name,0)
			return itemstack
		end

		pos.y=pos.y+1.5

-- the project

	for i=1, mcl_portalgun_max_rage,0.5 do
		local nname=minetest.get_node({x=pos.x+(dir.x*i), y=pos.y+(dir.y*i), z=pos.z+(dir.z*i)}).name
		if minetest.registered_nodes[nname].walkable then
			mcl_portalgun_portal[name].lifelime=mcl_portalgun_lifelime


			
			if minetest.get_node_group(nname, "antiportal")>0 then
				minetest.sound_play("mcl_portalgun_error", {pos=pos,max_hear_distance = 5, gain = 3})
				return itemstack
			end

			if minetest.registered_nodes[minetest.get_node({x=rnd(pos.x+(dir.x*i)), y=rnd(pos.y+(dir.y*i)+1), z=rnd(pos.z+(dir.z*i))}).name].walkable==false and rnd(user:getpos().y)>rnd(pos.y+(dir.y*i)) then
				mcl_portalgun_setportal(pos,name,dir,i,mode,"y+")
				return itemstack
			elseif minetest.registered_nodes[minetest.get_node({x=rnd(pos.x+(dir.x*i)), y=rnd(pos.y+(dir.y*i)-1), z=rnd(pos.z+(dir.z*i))}).name].walkable==false and rnd(user:getpos().y)<rnd(pos.y+(dir.y*i)) then
				mcl_portalgun_setportal(pos,name,dir,i,mode,"y-")
				return itemstack
			elseif minetest.registered_nodes[minetest.get_node({x=rnd(pos.x+(dir.x*i)-1), y=rnd(pos.y+(dir.y*i)), z=rnd(pos.z+(dir.z*i))}).name].walkable==false  and rnd(user:getpos().x)<rnd(pos.x+(dir.x*i)) then
				mcl_portalgun_setportal(pos,name,dir,i,mode,"x-")
				return itemstack
			elseif minetest.registered_nodes[minetest.get_node({x=rnd(pos.x+(dir.x*i))+1, y=rnd(pos.y+(dir.y*i)), z=rnd(pos.z+(dir.z*i))}).name].walkable==false and rnd(user:getpos().x)>rnd(pos.x+(dir.x*i)) then
				mcl_portalgun_setportal(pos,name,dir,i,mode,"x+")
				return itemstack
			elseif minetest.registered_nodes[minetest.get_node({x=rnd(pos.x+(dir.x*i)), y=rnd(pos.y+(dir.y*i)), z=rnd(pos.z+(dir.z*i)-1)}).name].walkable==false and rnd(user:getpos().z)<rnd(pos.z+(dir.z*i)) then
				mcl_portalgun_setportal(pos,name,dir,i,mode,"z-")
				return itemstack
			elseif minetest.registered_nodes[minetest.get_node({x=rnd(pos.x+(dir.x*i)), y=rnd(pos.y+(dir.y*i)), z=rnd(pos.z+(dir.z*i)+1)}).name].walkable==false and rnd(user:getpos().z)>rnd(pos.z+(dir.z*i)) then
				mcl_portalgun_setportal(pos,name,dir,i,mode,"z+")
				return itemstack
			end
			minetest.sound_play("mcl_portalgun_error", {pos=pos,max_hear_distance = 20, gain = 3})
			return itemstack
		end
	end
	return itemstack
end



function mcl_portalgun_setportal(pos,name,dir,i,mode,portal_dir)
	local lpos={x=pos.x+(dir.x*(i-1)), y=pos.y+(dir.y*(i-1)), z=pos.z+(dir.z*(i-1))}	-- last pos
	local cpos={x=pos.x+(dir.x*i), y=pos.y+(dir.y*i), z=pos.z+(dir.z*i)}		-- corrent poss

	if portal_dir=="y+" then cpos.y=(math.floor(cpos.y+ 0.5))+0.524
	elseif portal_dir=="y-" then cpos.y=(math.floor(cpos.y+ 0.5))-0.524
	elseif portal_dir=="z+" then cpos.z=(math.floor(cpos.z+ 0.5))+0.524
	elseif portal_dir=="z-" then cpos.z=(math.floor(cpos.z+ 0.5))-0.524
	elseif portal_dir=="x+" then cpos.x=(math.floor(cpos.x+ 0.5))+0.524
	elseif portal_dir=="x-" then cpos.x=(math.floor(cpos.x+ 0.5))-0.524
	end

	if portal_dir=="x+" or portal_dir=="x-" then -- auto correct (place in center)
		cpos.y=(math.floor(cpos.y+ 0.5))
		cpos.z=(math.floor(cpos.z+ 0.5))
	elseif portal_dir=="y+" or portal_dir=="y-" then
		cpos.x=(math.floor(cpos.x+ 0.5))
		cpos.z=(math.floor(cpos.z+ 0.5))
	elseif portal_dir=="z+" or portal_dir=="z-" then
		cpos.x=(math.floor(cpos.x+ 0.5))
		cpos.y=(math.floor(cpos.y+ 0.5))
	end

	if minetest.registered_nodes[minetest.get_node(cpos).name].walkable then
		minetest.sound_play("mcl_portalgun_error", {pos=pos,max_hear_distance = 5, gain = 3})
		return false
	end

	if string.find(portal_dir,"x",1) or string.find(portal_dir,"z",1) then-- auto correct (move from bottom / top)
		local testpos1={x=cpos.x,y=cpos.y-1,z=cpos.z}
		local testpos2={x=cpos.x,y=cpos.y+1,z=cpos.z}
		if minetest.registered_nodes[minetest.get_node(testpos1).name].walkable 
		and minetest.registered_nodes[minetest.get_node(testpos2).name].walkable==false then
		cpos.y=cpos.y+0.5
		elseif minetest.registered_nodes[minetest.get_node(testpos2).name].walkable 
		and minetest.registered_nodes[minetest.get_node(testpos1).name].walkable==false then
			cpos.y=cpos.y-0.5
		end
	end

	mcl_portalgun_portal_tmp_user=name
	mcl_portalgun_portal[name].x=pos.x-lpos.x
	mcl_portalgun_portal[name].y=pos.y-lpos.y
	mcl_portalgun_portal[name].z=pos.z-lpos.z 
	mcl_portalgun_portal[name].project=mode

	if mcl_portalgun_portal[name].x<0 then
		mcl_portalgun_portal[name].x=mcl_portalgun_portal[name].x*-1
	end
	if mcl_portalgun_portal[name].z<0 then
		mcl_portalgun_portal[name].z=mcl_portalgun_portal[name].z*-1
	end

	if mode==1 then
		portal_delete(name,1)
		mcl_portalgun_portal[name].portal1_use=mcl_portalgun_portal[name].portal1_use+1
		mcl_portalgun_portal[name].portal1_dir=portal_dir
		mcl_portalgun_portal[name].portal1_pos=cpos
		mcl_portalgun_portal[name].portal1=minetest.add_entity(cpos, "mcl_portalgun:portal")
		mcl_portalgun_portal[name].portal1_active=true
		minetest.sound_play("mcl_portalgun_portalblue", {pos=cpos, max_hear_distance = 20, gain = 1})
	else
		portal_delete(name,2)
		mcl_portalgun_portal[name].portal2_use=mcl_portalgun_portal[name].portal2_use+1
		mcl_portalgun_portal[name].portal2_dir=portal_dir
		mcl_portalgun_portal[name].portal2_pos=cpos
		mcl_portalgun_portal[name].portal2=minetest.add_entity(cpos, "mcl_portalgun:portal")
		mcl_portalgun_portal[name].portal2_active=true
		minetest.sound_play("mcl_portalgun_portalorange", {pos=cpos,max_hear_distance = 20, gain = 1})
	end
end